unit Unit1;

interface

{I ACRVer.inc}
{DEFINE REMOTE_DB}
{DEFINE EXCLUSIVE_DB}
{DEFINE EXCLUSIVE_TABLE}
{DEFINE USE_TRANSACTIONS}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,

  ACRMain, ACRConst, ACRTypes,
{$IFDEF DEBUG_LOG}
  ACRDebug,
{$ENDIF}

  DB, StdCtrls, ComCtrls,
  Spin, Grids, DBGrids;

type
  TForm1 = class(TForm)
    ACRDatabase1: TACRDatabase;
    ACRTable1: TACRTable;
    ACRQuery1: TACRQuery;
    bnInsert: TButton;
    reLog: TRichEdit;
    seRecQty: TSpinEdit;
    lbProgress: TLabel;
    bnOpenClose: TButton;
    bnExit: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    bnSelect: TButton;
    bnLocate: TButton;
    procedure FormCreate(Sender: TObject);
    procedure bnInsertClick(Sender: TObject);
    procedure bnOpenCloseClick(Sender: TObject);
    procedure bnExitClick(Sender: TObject);
    procedure bnSelectClick(Sender: TObject);
    procedure bnLocateClick(Sender: TObject);
  private
    { Private declarations }
    procedure InsertRecord(RecQty: Integer);
    procedure RunSelect(RecQty: Integer);
    procedure LocateRecord(RecQty: Integer);
  public
    { Public declarations }
    procedure ShowButtons(Enabled: Boolean);
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
{$IFDEF REMOTE_DB}
 ACRDatabase1.DatabaseFileNameAnsi := 'y:\data\test.adb';
{$ELSE}
 ACRDatabase1.DatabaseFileNameAnsi := IncludeTrailingBackslash(ExtractFilePath(ParamStr(0)))
  +'data\test.adb';
{$ENDIF}
{$IFDEF EXCLUSIVE_DB}
// exclusive SU
ACRDatabase1.Exclusive := True;
{$ELSE}
// file-server MU
ACRDatabase1.Exclusive := False;
{$ENDIF}

ACRQuery1.SQL.Text := 'CREATE TABLE test (id AutoInc, str Char(50), dt DateTime, code Integer, primary key (id)); CREATE INDEX idx_str ON test(str); CREATE INDEX idx_dt ON test(dt); CREATE INDEX idx_code ON test(code);';


{$IFDEF EXCLUSIVE_TABLE}
ACRTable1.Exclusive := True;
{$ELSE}
ACRTable1.Exclusive := False;
{$ENDIF}

 if (not ACRDatabase1.Exists) then
  begin
   ACRDatabase1.CreateDatabase;
   ACRDatabase1.Open;
   ACRQuery1.ExecSQL;
  end
 else
   ACRDatabase1.Open;

 ACRTable1.Open;
 bnOpenClose.Caption := 'Close';

 Self.Caption := 'Accuracer '+ACRTable1.CurrentVersion;
{$IFDEF REMOTE_DB}
 Self.Caption := Self.Caption + ' - REMOTE FILE';
{$ENDIF}
{$IFDEF USE_TRANSACTIONS}
 Self.Caption := Self.Caption + ' - TRANSACTIONS';
{$ENDIF}
{$IFDEF EXCLUSIVE_DB}
 Self.Caption := Self.Caption + ' - EXCLUSIVE';
{$ENDIF}

// bnOpenClose.Caption := 'Open';

end;

procedure TForm1.InsertRecord(RecQty: Integer);
var i,n: Integer;
const BaseText = 'String code: ';
begin
 if (not ACRTable1.Active) then
  ACRTable1.Open;
{$IFDEF USE_TRANSACTIONS}
ACRDatabase1.StartTransaction;
{$ENDIF}
 for i := 1 to RecQty do
  begin
   n := i mod 1000;
   if (n = 0) then
    begin
     lbProgress.Caption := 'i = '+IntToStr(i);
     Application.ProcessMessages;
     if (Application.Terminated) then break;
    end;
{$IFDEF DEBUG_LOG}
aaStartTime;
{$ENDIF}
   ACRTable1.Insert;
   ACRTable1.Fields[1].AsString := BaseText+Format('%06d',[n]);
   ACRTable1.Fields[2].AsDateTime := Now;
   ACRTable1.Fields[3].AsInteger := n;
{$IFDEF DEBUG_LOG}
aaStartTime(time19);
{$ENDIF}
   ACRTable1.Post;
{$IFDEF DEBUG_LOG}
aaStopTime(time19);
aaStopTime;
{$ENDIF}
 end; // for
{$IFDEF USE_TRANSACTIONS}
{$IFDEF DEBUG_LOG}
aaStartTime;
aaStartTime(time20);
{$ENDIF}
ACRDatabase1.Commit;
{$IFDEF DEBUG_LOG}
aaStopTime(time20);
aaStopTime;
{$ENDIF}
{$ENDIF}
end;

procedure TForm1.LocateRecord(RecQty: Integer);
var n,i: Integer;
begin
 if (not ACRTable1.Active) then
  ACRTable1.Open;
 for i := 1 to RecQty do
  begin
   n := i mod 1000;
   if (n = 0) then
    begin
     lbProgress.Caption := 'i = '+IntToStr(i);
     Application.ProcessMessages;
     if (Application.Terminated) then break;
    end;
{$IFDEF DEBUG_LOG}
aaStartTime;
{$ENDIF}
   ACRTable1.Locate('id',i,[]);
{$IFDEF DEBUG_LOG}
aaStopTime;
{$ENDIF}
 end; // for
end; // LocateRecord


procedure TForm1.RunSelect(RecQty: Integer);
var n,i: Integer;
begin
 for i := 1 to RecQty do
  begin
   n := i mod 1000;
   if (n = 0) then
    begin
     lbProgress.Caption := 'i = '+IntToStr(i);
     Application.ProcessMessages;
     if (Application.Terminated) then break;
    end;
{$IFDEF DEBUG_LOG}
aaStartTime;
{$ENDIF}
   ACRQuery1.SQL.Text := 'SELECT * FROM test WHERE id = '+IntToStr(i);
   ACRQuery1.Open;
   ACRQuery1.Close;
{$IFDEF DEBUG_LOG}
aaStopTime;
{$ENDIF}
 end; // for
end; // RunSelect


procedure TForm1.ShowButtons(Enabled: Boolean);
begin
 bnInsert.Enabled := Enabled;
 bnLocate.Enabled := Enabled;
 bnSelect.Enabled := Enabled;
 bnOpenClose.Enabled := Enabled;
 if (ACRTable1.Active) then
  begin
   if (Enabled) then
     ACRTable1.EnableControls
   else
     ACRTable1.DisableControls;
  end;
end;


procedure TForm1.bnInsertClick(Sender: TObject);
var t: Cardinal;
begin
 ShowButtons(False);
 {$IFDEF DEBUG_LOG}
 aaInitAll;
 {$ELSE}
 t := GetTickCount;
 {$ENDIF}
 try
  try
   InsertRecord(seRecQty.Value);
  except
   on e: Exception do
    begin
     reLog.Lines.Add('Error: '+#13#10+e.Message)
    end;
  end;
 finally
  {$IFDEF DEBUG_LOG}
  aaWriteAllTimesToLog;
  aaWriteAllCountersToLog;
  reLog.Lines.LoadFromFile(aaGetLogFileName);
  {$ELSE}
  t := GetTickCount-t;
  reLog.Lines.Add('Insert time, ms = '+IntToStr(t));
  reLog.Lines.SaveToFile('test_result.txt');
  {$ENDIF}
  ShowButtons(true);
 end;
end;

procedure TForm1.bnOpenCloseClick(Sender: TObject);
begin
 if (bnOpenClose.Caption = 'Close') then
  begin
   ACRTable1.Close;
   bnOpenClose.Caption := 'Open';
  end
 else
  begin
   ACRTable1.Open;
   bnOpenClose.Caption := 'Close';
  end;
end;

procedure TForm1.bnExitClick(Sender: TObject);
begin
Close;
Application.Terminate;
end;

procedure TForm1.bnSelectClick(Sender: TObject);
var t: Cardinal;
begin
 ShowButtons(False);
 {$IFDEF DEBUG_LOG}
 aaInitAll;
 {$ELSE}
 t := GetTickCount;
 {$ENDIF}
 try
  RunSelect(seRecQty.Value);
 finally
  {$IFDEF DEBUG_LOG}
  aaWriteAllTimesToLog;
  aaWriteAllCountersToLog;
  reLog.Lines.LoadFromFile(aaGetLogFileName);
  {$ELSE}
  t := GetTickCount-t;
  reLog.Lines.Add('SELECT time, ms = '+IntToStr(t));
  reLog.Lines.SaveToFile('test_result.txt');
  {$ENDIF}
  ShowButtons(true);
 end;
end;

procedure TForm1.bnLocateClick(Sender: TObject);
var t: Cardinal;
begin
 ShowButtons(False);
 {$IFDEF DEBUG_LOG}
 aaInitAll;
 {$ELSE}
 t := GetTickCount;
 {$ENDIF}
 try
  LocateRecord(seRecQty.Value);
 finally
  {$IFDEF DEBUG_LOG}
  aaWriteAllTimesToLog;
  aaWriteAllCountersToLog;
  reLog.Lines.LoadFromFile(aaGetLogFileName);
  {$ELSE}
  t := GetTickCount-t;
  reLog.Lines.Add('Locate time, ms = '+IntToStr(t));
  reLog.Lines.SaveToFile('test_result.txt');
  {$ENDIF}
  ShowButtons(true);
 end;
end;

end.
